with Ada.Numerics.Float_Random;
use Ada.Numerics.Float_Random;
package body Random_Numbers is
   Gen : Generator;
   
   procedure Reset is
   begin
      Reset (Gen );
   end Reset;

   function Random (N : Positive) return Positive is
      Result      : Integer range 1 .. N;
   begin  -- Returns a number in the range 1..N
      Result      := 1 + Integer( Float(N) * Random(Gen) ) mod N;
      -- Sensitive to possibility of Random generating 1.0
      return Result;
   end Random;
end Random_Numbers;
