with Ada.Text_IO, Ada.Integer_Text_IO, Ada.Unchecked_Deallocation;
use Ada.Text_IO, Ada.Integer_Text_IO;
procedure Gnatmem_Test is
   N1, N2, N3, N4 : Integer;
begin
   Put("How many objects to be freed properly: ");
   Get(N1);
   Put("How many objects to be referenced danglingly: ");
   Get(N2);
   Put("How many declared objects to be freed (incorrectly): ");
   Get(N3);
   Put("How many objects to be left as garbage (unfreed, unreferenced): ");
   Get(N4);
   
   declare
      type Int_Ref is access all Integer;
      procedure Free is new Ada.Unchecked_Deallocation( Integer, Int_Ref );
      type Int_Ref_Array is array(Positive range <>) of Int_Ref;
      
      Properly_Freed : Int_Ref_Array (1..N1) := (others => new Integer);
      Dangling_Freed : Int_Ref_Array (1..N2) := (others => new Integer);
      Danglers       : Int_Ref_Array (1..N2) := Dangling_Freed;
      Objs           : array (1..N3) of aliased Integer;
      Freed_Decls    : Int_Ref_Array (1..N3);
      Ref            : Int_Ref;
   begin
      for I in Properly_Freed'Range loop
         Free( Properly_Freed(I) );
      end loop;
      
      for I in Dangling_Freed'Range loop
         Free( Dangling_Freed(I) );
      end loop;
      
      for I in Freed_Decls'Range loop
         Freed_Decls(I) := Objs(I)'Access;
         Free( Freed_Decls(I) );
      end loop;
      
      for I in 1..N4 loop
         Ref := new Integer;
      end loop;
      Ref := null;
   end;
end Gnatmem_Test;
   