with Ada.Text_IO; use Ada.Text_IO;
with Ada.Float_Text_IO;  use Ada.Float_Text_IO;
with Ada.Integer_Text_IO;  use Ada.Integer_Text_IO;
with Random_Numbers; use Random_Numbers;
procedure Dice_Simulation is
   Throws      : Integer;
   Frequency   : array (2 .. 12) of Natural := (others => 0);
   Sum         : Integer range 2 .. 12;
   Probability : constant array (2 .. 12) of Float range 0.0 .. 1.0 :=
      (2 | 12 => 1.0 / 36.0,
       3 | 11 => 2.0 / 36.0,
       4 | 10 => 3.0 / 36.0,
       5 | 9  => 4.0 / 36.0,
       6 | 8  => 5.0 / 36.0,
       7      => 6.0 / 36.0);
   Expected_Frequency : array (2 .. 12) of Float;
begin
   Put ("How many throws? ");
   Get (Throws);
   for I in 1 .. Throws loop
      Sum             := Random (6) + Random (6);
      Frequency (Sum) := Frequency (Sum) + 1;
   end loop;
   for I in 2 .. 12 loop
      Expected_Frequency (I) := Float (Throws) * Probability (I);
   end loop;

   Put_Line ("   SUM    FREQUENCY  EXPECTED FREQUENCY");
   for I in 2 .. 12 loop
      Put (I, Width=>6);
      Set_Col (10);
      Put (Frequency (I), Width=>10);
      Set_Col (34);
      Put (Expected_Frequency (I), Aft => 2, Exp => 0);
      New_Line;
   end loop;
end Dice_Simulation;
