package body Parity_Pkg is
   function Odd_Parity(Item : Symbol_String) return Boolean is
      -- Returns True if Item contains an odd number of 1's
      -- Returns False otherwise
   
      type State is (Q0, Q1);
      type Transition_Matrix is array(State, Symbol) of State;

   
      FSM : constant Transition_Matrix :=
          (Q0 => ('0' => Q0, '1' => Q1),
           Q1 => ('0' => Q1, '1' => Q0));
      Q : State := Q0;
   begin
     for I in Item'Range loop
       Q := FSM(Q, Item(I));
     end loop;
     return Q = Q1;
   end Odd_Parity;
end Parity_Pkg;
