with Generic_Shuffle, Ada.Text_IO, Ada.Integer_Text_IO;
use Ada.Text_IO, Ada.Integer_Text_IO;
with Random_Numbers; 
procedure Array_Test2 is
   Num_Shuffles : Integer;
   type Perm is array(Positive range <>) of Integer;

   procedure Shuffle is new Generic_Shuffle(Integer, Perm);

   P : Perm := (1, 2, 3, 4);

   Perms : constant array(1..24) of Perm(1..4) :=
    ( (1, 2, 3, 4), (1, 2, 4, 3), (1, 3, 2, 4), (1, 3, 4, 2), (1, 4, 2, 3), (1, 4, 3, 2),
      (2, 1, 3, 4), (2, 1, 4, 3), (2, 3, 1, 4), (2, 3, 4, 1), (2, 4, 1, 3), (2, 4, 3, 1),
      (3, 1, 2, 4), (3, 1, 4, 2), (3, 2, 1, 4), (3, 2, 4, 1), (3, 4, 1, 2), (3, 4, 2, 1),
      (4, 1, 2, 3), (4, 1, 3, 2), (4, 2, 1, 3), (4, 2, 3, 1), (4, 3, 1, 2), (4, 3, 2, 1) );

   Freq : array(1..24) of Natural := (others => 0);
   
   function Index( P : Perm) return Integer is
   begin
      for I in Perms'Range loop
         if P = Perms(I) then
           return I;
         end if;
      end loop;
      raise Program_Error;
   end Index;

   Ind : Integer;
begin
   Put("Number of shuffles: ");
   Get(Num_Shuffles);
   for I in 1..Num_Shuffles loop
      Random_Numbers.Reset;
      Shuffle(P);          -- Shuffles the array
      Ind := Index(P);
      Freq(Ind) := Freq(Ind)+1;
   end loop;
   for I in Freq'Range loop
     Put_Line(I'Img & ": " & Freq(I)'Img);
   end loop;
end Array_Test2;
