with Day_Pkg; use Day_Pkg;
with Ada.Text_IO; use Ada.Text_IO;
procedure Day_Test_Robust is
   D1, D2 : Day;
   N      : Integer;
   Line   : String(1..80);
   Last   : Natural;
begin
   Put_Line("When prompted for a Day value, enter one of: ");
   for D in Day loop
      Put(Day'Image(D) & "  ");
   end loop;
   New_Line;
   Put_Line("Starting tests for Day+Integer...");
   loop
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;
      begin
        D1 := Day'Value(Line(1..Last));
      exception
        when Constraint_Error =>
           D1 := Sun;
           Put_Line("Bogus Day value; assuming Sun");
      end;
      loop
         begin
            Put("Type an integer: "); 
            Get_Line(Line, Last);
            N := Integer'Value(Line(1..Last));
            exit;
         exception
            when Constraint_Error =>
               Put("Bad value, try again... ");
         end;
      end loop;
      D2 := D1 + N;  -- The code being tested
      Put_Line("Result of " & Day'Image(D1) & "+" & Integer'Image(N) & 
               " is " & Day'Image(D2));
   end loop;
   Put_Line("Starting tests for Day-Day...");
   loop
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;
      begin
        D1 := Day'Value(Line(1..Last));
      exception
        when Constraint_Error =>
           D1 := Sun;
           Put_Line("Bogus Day value; assuming Sun");
      end;
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;
      begin
        D2 := Day'Value(Line(1..Last));
      exception
        when Constraint_Error =>
           D2 := Sun;
           Put_Line("Bogus Day value; assuming Sun");
      end;
      N := D1 - D2;  -- The code being tested
      Put_Line("Result of " & Day'Image(D1) & "-" &
                Day'Image(D2) & " is " & Integer'Image(N));
   end loop;
end Day_Test_Robust;