with Day_Pkg; use Day_Pkg;
with Ada.Text_IO; use Ada.Text_IO;
procedure Day_Test_Robust_2 is
   D1, D2 : Day;
   N      : Integer;
   Line   : String(1..80);
   Last   : Natural;

   procedure String_To_Day(S : in String;
                           D : out Day;
                           Default : in Day := Sun) is
   begin
      D := Day'Value(S);
   exception
      when Constraint_Error =>
         D := Default;
         Put_Line("Bogus day, assuming " & Day'Image(Default));
   end String_To_Day;

begin
   Put_Line("When prompted for a Day value, enter one of: ");
   for D in Day loop
      Put(Day'Image(D) & "  ");
   end loop;
   New_Line;
   Put_Line("Starting tests for Day+Integer...");
   loop
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;

      String_To_Day(Line(1..Last), D1);

      loop
         begin
            Put("Type an integer: ");
            Get_Line(Line, Last);
            N := Integer'Value(Line(1..Last));
            exit;
         exception
            when Constraint_Error =>
               Put("Bad value, try again... ");
         end;
      end loop;
      D2 := D1 + N;  -- The code being tested
      Put_Line("Result of " & Day'Image(D1) & "+" & Integer'Image(N) &
               " is " & Day'Image(D2));
   end loop;
   Put_Line("Starting tests for Day-Day...");
   loop
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;

      String_To_Day(Line(1..Last), D1);

      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;

      String_To_Day(Line(1..Last), D2);

      N := D1 - D2;  -- The code being tested
      Put_Line("Result of " & Day'Image(D1) & "-" &
                Day'Image(D2) & " is " & Integer'Image(N));
   end loop;
end Day_Test_Robust_2;
