with Ada.Text_IO, Ada.Float_Text_IO;
use Ada.Text_IO, Ada.Float_Text_IO;
package body Vector_Pkg_2 is
   procedure Init ( V : out Vector ) is 
   begin
      for I in V'Range loop
         Put("Type a number: ");
         Get( V(I) );
      end loop;
   end Init;

   procedure Display ( V : in Vector ) is 
   begin
      for I in V'range loop
         Put("Element" & Integer'Image(I) & ": ");
         Put( V(I),
           Aft => 2, 
           Exp => 0);
         New_Line;
      end loop;
   end Display;

   procedure Sort ( V : in out Vector ) is 
      Temp : Float;  
   begin
      for I in V'First .. V'Last-1 loop
         for J in I+1 .. V'Last loop
            if V (J) < V (I) then
               Temp := V (I);
               V(I) := V (J);
               V(J) := Temp;
            end if;
         end loop;
      end loop;
   end Sort;

   function "*" ( L : Integer;  R : Vector  )  return Vector is 
      -- Multiplies each element of R by L
      -- Returned Vector has lower bound = 1
      Result : Vector (1 .. R'Length) := R;  
   begin
      for I in Result'range loop
         Result(I) := Float(L) * Result(I);
      end loop;
      return Result;
   end "*";

   function "*" ( L,  R : Vector  )  return Float is 
      Sum : Float := 0.0;
   begin
      if L'Length /= R'Length then
         raise Parameter_Length_Error;
      end if;
      for I in L'Range loop
         Sum := Sum + L(I) * R(R'First+I-1);
      end loop;
      return Sum;
   end "*";
end Vector_Pkg_2;
