package body Integrate_Pkg is
--   type Func_Ref is access function(X : Float) return Float;

  function Integrate( Func          : Func_Ref;
                      X_Low, X_High : Float;
                      N             : Positive ) return Float is
     Total_Area : Float := 0.0;
     Trap_Width : Float := (X_High-X_Low) / Float(N);
     X_Left     : Float := X_Low;
     X_Right    : Float := X_Low + Trap_Width;
     Trap_Area  : Float;
  begin
     for I in 1..N loop
        Trap_Area := 0.5 * (Func(X_Right)+Func(X_Left)) * Trap_Width;
        Total_Area := Total_Area + Trap_Area;
        X_Left  := X_Right;
        X_Right := X_Right + Trap_Width;
     end loop;
     return Total_Area;
  end Integrate;
end Integrate_Pkg;
