with Ada.Text_IO; use Ada.Text_IO;
with Ada.Unchecked_Deallocation;
package body String_List_Pkg is
--     type String_Ref is access String;
--     type Node;
--     type Node_Ref is access Node;
--     type Node is
--        record
--           Data : String_Ref;
--           Next : Node_Ref;
--        end record;
   procedure Get( Ref : out Node_Ref ) is
      Line : String(1..80);
      Last : Natural;
   begin
      loop
         Put("Type a string (empty line to exit): ");
         Get_Line(Line, Last);
         exit when Last=0;
         Ref := new Node'( new String'( Line(1..Last)), Ref);
      end loop;
   end Get;

   procedure Put( Ref : Node_Ref ) is
      L : Node_Ref := Ref;
   begin
      while L /= null loop
         Put_Line(L.Data.all);
         L := L.all.Next;
      end loop;
   end;

   procedure Free_String is new Ada.Unchecked_Deallocation(String, String_Ref);
   procedure Free_Node is new Ada.Unchecked_Deallocation(Node, Node_Ref);
   procedure Reclaim ( Ref : in out Node_Ref ) is
   begin
      if Ref /= null then
         Reclaim(Ref.all.Next);
         Free_String(Ref.all.Data);
         Free_Node(Ref);
      end if;
   end Reclaim;
end String_List_Pkg;
