package body Int_Stack_Pkg is
--   subtype Element_Type is Integer);
--   Overflow, Underflow : exception;
--   type Element_Array is array(Positive range <>) of Element_Type;
--   type Stack(Max_Size : Natural) is 
--      record
--         Current_Size : Natural := 0;
--         Data         : Element_Array(1..Max_Size);
--      end record;

   procedure Push(S : in out Stack; E : in Element_Type) is
   begin
      if S.Current_Size = S.Max_Size then
         raise Overflow;
      end if;
      S.Current_Size := S.Current_Size+1;
      S.Data(S.Current_Size) := E;
   end Push;
   
   procedure Pop(S : in out Stack; E : out Element_Type) is
   begin
      if S.Current_Size = 0 then
         raise Underflow;
      end if;
      S.Current_Size := S.Current_Size-1;
      E := S.Data(S.Current_Size+1);
   end Pop;

   function Top( S : Stack ) return Element_Type is
   begin
      return S.Data(S.Current_Size);
   exception
      when Constraint_Error =>
         raise Underflow;
   end Top;
   
   function Current_Size(S : Stack) return Natural is
   begin
      return S.Current_Size;
   end Current_Size;
end Int_Stack_Pkg;


   