with Int_Stack_Pkg; use Int_Stack_Pkg;
with Ada.Text_IO; use Ada.Text_IO;
with Ada.Integer_Text_IO; use Ada.Integer_Text_IO;
procedure Int_Stack_Test is
   Max_Size : Integer;
   E : Integer;
   Char : Character;
   N : Integer := 100;
begin
  Put("Max size of stack: ");
  Get(Max_Size);
  declare
     S : Stack(Max_Size);
  begin
     Put_Line(" At the prompt, type '+' for Push, '-' for Pop,");
     Put_Line(" '=' for Top, '#' for Current_Size, 'q' to quit");
     loop
        Put("+-=#q ");
        Get(Char);
        exit when Char = 'q' or Char = 'Q';
        case Char is
          when '+' =>
             begin
                Push(S, N);
                Put_Line("Pushed value" & Integer'Image(N) );
                N := N+100;
             exception
                when Overflow =>
                   Put_Line("Stack is full, can't push");
             end;
          when '-' =>
             begin
                Pop(S, E);
                Put_Line("Popped value" & Integer'Image(E));
             exception
                when Underflow =>
                   Put_Line("Stack is empty, can't pop");
             end;
          when '=' =>
             begin
                E := Top(S);
                Put_Line("Top is " & Integer'Image(E));
             exception
                when Underflow =>
                   Put_Line("Stack is empty, can't take Top");
             end;
          when '#' =>
              E := Current_Size(S);
              Put_Line("Current size is " & Integer'Image(E));
          when others =>
             Put_Line("Not a legal response.  Try again");
        end case;
     end loop;
  end;
end Int_Stack_Test;
             