generic
   type Element_Type is private;
package Generic_Stack_Pkg is
   type Stack(Max_Size : Natural) is limited private;
   procedure Push(S : in out Stack; E : in Element_Type);
   procedure Pop(S : in out Stack; E : out Element_Type);
   function Top( S : Stack ) return Element_Type;
   function Current_Size(S : Stack) return Natural;
   Overflow, Underflow : exception;
private
   type Element_Array is array(Positive range <>) of Element_Type;
   type Stack(Max_Size : Natural) is 
      record
         Current_Size : Natural := 0;
         Data         : Element_Array(1..Max_Size);
      end record;
end Generic_Stack_Pkg;


   