function Generic_Integrate( X_Low, X_High : Floating;
                            N             : Positive ) return Floating is
   Total_Area : Floating := 0.0;
   Trap_Width : Floating := (X_High-X_Low) / Floating(N);
   X_Left     : Floating := X_Low;
   X_Right    : Floating := X_Low + Trap_Width;
   Trap_Area  : Floating;
begin
   for I in 1..N loop
      Trap_Area := 0.5 * (Func(X_Right)+Func(X_Left)) * Trap_Width;
      Total_Area := Total_Area + Trap_Area;
      X_Left  := X_Right;
      X_Right := X_Right + Trap_Width;
   end loop;
   return Total_Area;
end Generic_Integrate;
