with Ada.Text_IO; use Ada.Text_IO;
with Ada.Integer_Text_IO; use Ada.Integer_Text_IO;
procedure Text_File_Test is 
   File               : File_Type;  
   Max_Chars_Per_Line : constant  :=  100;  
   Line               : String (1 .. Max_Chars_Per_Line);
      
   Last               : Natural;  
   Frequencies        : array (0 .. Max_Chars_Per_Line) of Natural := 
     (others => 0);  
   Line_Count         : Natural := 0;  
begin
   Put("What is the name of the text file? ");
   Get_Line(Line, Last);
   begin
      Open(File, Mode => In_File, Name => Line(1..Last));
   exception
      when others =>
         Put_Line("Sorry, cannot open file");
         return;
   end;
   loop
      Get_Line(File, Line, Last);
      Line_Count := Line_Count+1;
      Frequencies(Last) := Frequencies(Last)+1;
      if Last = Line'Last then
         Skip_Line;  -- Ignore characters beyond 100
      end if;
   end loop;
exception
   when End_Error =>
      Put_Line("Number of lines: " & Integer'Image(Line_Count));
      Put_Line("Length  Frequency");
      for I in Frequencies'Range loop
         if Frequencies(I) > 0 then
            Put( I, Width => 6 );
            Put( Frequencies(I), Width => 11 );
            New_Line;
         end if;
      end loop;
      Close(File);
end Text_File_Test;
         
      
      
      